<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: VTA_FormaPago.xml */
/* Generado: 2021-09-16 05:34:51 */

/* Mantenimiento de los registros de la tabla VTA_FormaPago */
abstract class BaseVTA_FormaPagoDP extends VTA_FormaPagoBV
{
    /* Constructor ( Establece los valores desde un objeto VTA_FormaPagoBN ) */
    public function __construct( VTA_FormaPagoBN $o_VTA_FormaPagoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_VTA_FormaPagoBN ) )
        {
            $this->setByBN( $o_VTA_FormaPagoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto VTA_FormaPagoBN */
    public function setByBN( VTA_FormaPagoBN $o_VTA_FormaPagoBN )
    {
        if ( !is_null( $o_VTA_FormaPagoBN->getIdFormaPago() ) )
        {
            $this->setIdFormaPago( $o_VTA_FormaPagoBN->getIdFormaPago() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getDescripcionLocal() ) )
        {
            $this->setDescripcionLocal( $o_VTA_FormaPagoBN->getDescripcionLocal() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getCodigo() ) )
        {
            $this->setCodigo( $o_VTA_FormaPagoBN->getCodigo() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getCodigoSunat() ) )
        {
            $this->setCodigoSunat( $o_VTA_FormaPagoBN->getCodigoSunat() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getContadoFlag() ) )
        {
            $this->setContadoFlag( $o_VTA_FormaPagoBN->getContadoFlag() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getDias() ) )
        {
            $this->setDias( $o_VTA_FormaPagoBN->getDias() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getEstado() ) )
        {
            $this->setEstado( $o_VTA_FormaPagoBN->getEstado() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_VTA_FormaPagoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_VTA_FormaPagoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_VTA_FormaPagoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_VTA_FormaPagoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_VTA_FormaPagoBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_VTA_FormaPagoFN = new VTA_FormaPagoFN();
        $o_VTA_FormaPagoBN = $o_VTA_FormaPagoFN->selectByPk( $this->getIdFormaPago() );
        if ( is_null( $o_VTA_FormaPagoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO VTA_FormaPago ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdFormaPago() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdFormaPago";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdFormaPago()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcionLocal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DescripcionLocal";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcionLocal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Codigo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CodigoSunat";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ContadoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getContadoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDias() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Dias";
                $s_SQLQuery2 .= $s_Separator."".$this->getDias()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE VTA_FormaPago SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcionLocal() ) )
            {
                $s_SQLQuery .= $s_Separator."DescripcionLocal = '".$this->getDescripcionLocal()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery .= $s_Separator."Codigo = '".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigoSunat() ) )
            {
                $s_SQLQuery .= $s_Separator."CodigoSunat = '".$this->getCodigoSunat()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."ContadoFlag = '".$this->getContadoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDias() ) )
            {
                $s_SQLQuery .= $s_Separator."Dias = ".$this->getDias()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdFormaPago = '".$this->getIdFormaPago()."';";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM VTA_FormaPago WHERE  IdFormaPago = '".$this->getIdFormaPago()."';";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>